#ifndef TGT__SHAPER_H
#define TGT__SHAPER_H

#include <stdint.h>

enum tgt_shaper {
	SHAPE_IOPS=0,
	SHAPE_KBPS,
	SHAPE_LIMIT,
};

struct tba_shaper {
	uint64_t cbs;		/* committed burst size */
	uint64_t capacity;       /* current capacity in units */
	uint64_t out_rate;       /* outgoing rate in units per seconds */
	struct timespec last_tick;	/* last tick absolute time */
	void* cb_arg;		/* argument for wakeup_cb */
	void (*wakeup_cb)(struct tba_shaper *s); /* called when capacity increased */
};

int shaper_cmd_enabled(struct scsi_cmd *cmd);
int shaper_init(void);
void shaper_close(void);

#endif	/* TGT__SHAPER_H */
